package com.urbandroid.sleep.captchapack.flags;

import android.content.Context;
import android.content.res.AssetManager;

import com.opencsv.CSVReader;

import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

public class CsvReader {

    public List<Flag> readCsv(final Context context) {

        final Map<String, Flag> result = new LinkedHashMap<>();
        AssetManager assetManager = context.getAssets();

        try {
            //InputStream csvStream = assetManager.open("iso_3166_2_countries.csv");
            InputStream csvStream = assetManager.open("cow.csv");
            InputStreamReader csvStreamReader = new InputStreamReader(csvStream);
            CSVReader csvReader = new CSVReader(csvStreamReader, ',');
            String[] line;

            // throw away the header
            csvReader.readNext();

            int counter = 0;
            String iso;
            Flag flag;

            while ((line = csvReader.readNext()) != null) {
                iso = line[0].toLowerCase();
                result.get(iso);
                flag = result.get(iso);
                if (flag == null) {
                    flag = new Flag().iso(iso);
                    result.put(iso, flag);
                }
                String population = line[29];
                if ( population != null && !population.isEmpty()) {
                    flag.population(Integer.parseInt(population));
                }
                //questionList.add(new Flag(line[10].toLowerCase(), line[1]));
                //System.out.println("------------ " + line[0] + " " + line[29]);
                if (line.length < 67 || !"en-us".equals(line[67])) {
                    counter++;
                    continue;
                }
                try {
                    flag.name(line[70]);
                }catch (Exception e) {
                    //System.err.println(counter + " ----: " + Arrays.asList(line));
                }
                counter++;
            }

        } catch (IOException e) {
            e.printStackTrace();
        }
        return new ArrayList<>(result.values());
    }

}
