package com.urbandroid.sleep.captchapack.flags;

import android.content.Context;
import android.support.annotation.DrawableRes;

import java.io.Serializable;

public class Flag implements Serializable {

    private String name;
    private String iso;
    private long land;
    private long population;

    public Flag iso(String iso) {
        this.iso = iso;
        return this;
    }

    public Flag name(String name) {
        this.name = name;
        return this;
    }

    public Flag land(long land) {
        this.land = land;
        return this;
    }

    public Flag population(long population) {
        this.population = population;
        return this;
    }

    public String getName() {
        return name;
    }

    public String getIso() {
        return iso;
    }

    public long getLand() {
        return land;
    }

    public long getPopulation() {
        return population;
    }

    @DrawableRes
    public int getResource(Context context){
        return context.getResources().getIdentifier("drawable/" + (iso.equals("do") ? "d_o": iso), null, context.getPackageName());
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof Flag)) return false;

        Flag flag = (Flag) o;

        return iso.equals(flag.iso);

    }

    @Override
    public int hashCode() {
        return iso.hashCode();
    }

    @Override
    public String toString() {
        return "Flag{" +
                "iso='" + iso + '\'' +
                ", name='" + name + '\'' +
                '}';
    }
}
