package com.urbandroid.sleep.captchapack.flags;

import android.content.Context;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

public class FlagManager {

    private final Context context;
    private final Random random = new Random();

    public FlagManager(Context context) {
        this.context = context;
    }

    public List<Flag> take(final int numberOfFlags) {

        final List<Flag> all = new CsvReader().readCsv(context);

        System.err.println(" ----: SIZE " + all.size());

        final List<Flag> result = new ArrayList<>();

        int counter = 0;
        while (counter < numberOfFlags) {
            Flag flag = pick(all);
            if (result.contains(flag) || flag.getPopulation() < 40000000) {
                continue;
            }
            result.add(flag);
            counter++;
        }
        return result;
    }

    private Flag pick(final List<Flag> all) {
        return all.get(random.nextInt(all.size()));
    }

}
