package com.urbandroid.sleep.captchapack.multi;

import android.content.Intent;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.util.Log;
import android.widget.ListView;

import com.urbandroid.sleep.captchapack.BaseCaptcha;
import com.urbandroid.sleep.captchapack.R;

public abstract class BaseMultiCaptchaConfig extends BaseCaptcha {

    protected abstract String getSettingsKey();

    @Override
    protected void onNewIntent(Intent intent) {
        super.onNewIntent(intent);

        Log.i(TAG, "MultiCaptchaConfig: onNewIntent");
    }

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        Log.i(TAG, "MultiCaptcha: onCreate");

        setContentView(R.layout.activity_captcha_multi);

        ListView listView = ((ListView)findViewById(R.id.list));
        CaptchaAdapter adapter = new CaptchaAdapter(getApplicationContext(), listView, getCaptchaSupport(), getSettingsKey());
        listView.setChoiceMode(ListView.CHOICE_MODE_MULTIPLE);
        listView.setItemsCanFocus(false);
        listView.setAdapter(adapter);
        listView.setOnItemClickListener(adapter);

    }



}
