package com.urbandroid.sleep.captchapack.multi;

import android.os.Handler;
import android.util.Log;
import com.urbandroid.sleep.captcha.domain.CaptchaInfo;
import com.urbandroid.sleep.captchapack.context.SettingKeys;

import java.util.List;

public class InOrderCaptcha extends BaseMultiCaptcha {

    @Override
    protected int getGoal() {
        return settings.loadList(SettingKeys.KEY_CAPTCHA_IN_ORDER_LIST, SettingKeys.LIST_SEPARATOR, SettingKeys.DEFAULT_MULTI_CAPTCHA_LIST).size();
    }

    public boolean launchNextCaptcha() {
        List<String> captchaIds = settings.loadList(SettingKeys.KEY_CAPTCHA_IN_ORDER_LIST, SettingKeys.LIST_SEPARATOR, SettingKeys.DEFAULT_MULTI_CAPTCHA_LIST);
        if (captchaIds.size() > 0) {
            String id = captchaIds.get(getProgress());
            final CaptchaInfo nextCaptcha = getCaptchaSupport().getFinder().findById(Integer.parseInt(id));
            if (nextCaptcha != null) {

                Handler h = new Handler();
                h.postDelayed(new Runnable() {
                    @Override
                    public void run() {
                        getCaptchaSupport().getLauncher().start(nextCaptcha);
                    }
                }, 1000);

            Log.i(TAG, "MultiCaptcha: launching next " + nextCaptcha.getActivityName());
                return true;
            }
        }
        return false;
    }

}
