package com.urbandroid.sleep.captchapack.multi;

import android.os.Handler;
import android.util.Log;
import com.urbandroid.sleep.captcha.domain.CaptchaInfo;
import com.urbandroid.sleep.captchapack.BaseCaptcha;
import com.urbandroid.sleep.captchapack.context.SettingKeys;
import com.urbandroid.sleep.captchapack.util.RandUtil;

import java.util.List;

public class RandomCaptcha extends BaseMultiCaptcha {


    @Override
    protected int getGoal() {
        return getCaptchaSupport().getDifficulty();
    }

    public boolean launchNextCaptcha() {
        List<String> captchaIds = settings.loadList(SettingKeys.KEY_CAPTCHA_RANDOM_LIST, SettingKeys.LIST_SEPARATOR, SettingKeys.DEFAULT_MULTI_CAPTCHA_LIST);

        if (captchaIds.size() > 0){
            for (int i = 0; i < getCaptchaSupport().getDifficulty(); i++) {
                String id = captchaIds.get(RandUtil.range(0, captchaIds.size() - 1));
                final CaptchaInfo randomCaptcha = getCaptchaSupport().getFinder().findById(Integer.parseInt(id));
                if (randomCaptcha != null) {
                    Log.i(BaseCaptcha.TAG, "MultiCaptcha: launching next " + randomCaptcha.getActivityName());

                    Handler h = new Handler();
                    h.postDelayed(new Runnable() {
                        @Override
                        public void run() {
                            getCaptchaSupport().getLauncher().start(randomCaptcha);
                        }
                    }, 1000);

                    return true;
                }
            }
            return false;
        }

        return false;
    }

}
