package com.urbandroid.sleep.captchapack.zombie;

import android.content.Context;
import android.graphics.drawable.AnimationDrawable;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Build;
import android.os.Bundle;
import android.util.Log;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;
import com.urbandroid.sleep.captchapack.BaseCaptcha;
import com.urbandroid.sleep.captchapack.R;

public class ZombieWalkCaptcha extends BaseCaptcha implements SensorEventListener {


    private SensorManager sensorManager;

    private Sensor stepDetector;

    private int target = 15;

    private int steps = 0;

    private AnimationDrawable anim;

    @Override
    protected void onSaveInstanceState(Bundle outState) {
        super.onSaveInstanceState(outState);
        outState.putInt("steps", steps);
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_pedo);

        if (Build.VERSION.SDK_INT < 19) {
            Toast.makeText(getApplicationContext(), getString(R.string.compatibility, getString(R.string.label_pedo), "4.4"), Toast.LENGTH_LONG).show();
            getCaptchaSupport().solved();
            finish();
        }

        target = getCaptchaSupport().getDifficulty() * 15;

        sensorManager = (SensorManager) getSystemService(Context.SENSOR_SERVICE);

        stepDetector = sensorManager.getDefaultSensor(Sensor.TYPE_STEP_DETECTOR);

        if (stepDetector == null) {
            Toast.makeText(this, R.string.compatibility_sensor, Toast.LENGTH_LONG).show();
            getCaptchaSupport().solved();
            finish();
        }

        if (savedInstanceState != null) {
            steps = savedInstanceState.getInt("steps");
        }
        updateSteps();

    }




    private void animate() {
        ImageView img = (ImageView)findViewById(R.id.bg);
        img.setBackgroundDrawable(null);
        img.setBackgroundResource(R.drawable.bg_anim);
        anim = (AnimationDrawable) img.getBackground();
        anim.setOneShot(true);
        anim.start();
    }


    @Override
    protected void onStart() {
        super.onStart();

        animate();

        sensorManager.registerListener(this, stepDetector, SensorManager.SENSOR_DELAY_NORMAL);
    }

    @Override
    protected void onStop() {
        super.onStop();
        sensorManager.unregisterListener(this, stepDetector);
    }

    private void updateSteps() {
        getSupportActionBar().setTitle(getResources().getString(R.string.steps, String.valueOf(Math.max(0,target - steps))));
    }

    public void onSensorChanged(SensorEvent event) {

        steps++;

        animate();

        if((target - steps) <= 0) {
            getCaptchaSupport().solved();
            finish();
        }

        updateSteps();
    }

    @Override
    public void onAccuracyChanged(Sensor sensor, int accuracy) {

    }

}

